import greenfoot.*;  // (World, Actor, GreenfootImage, and Greenfoot)
import java.util.*;
import java.awt.*;

/**
 * 
 * 
 * 
 */
public class Sonar extends Mover
{
    private int life = 60;
    private boolean destroy = false;
    
    public Sonar()
    {
    }
    
    public Sonar(int rotation)
    {
        GreenfootImage image = getImage();
        image.scale(5,7);
        setRotation(rotation);
        increaseSpeed(new Vector(getRotation(), 10));        
    }
    
    public void act()
    {
            if(life <= 0) {
            getWorld().removeObject(this);
            } else {
            move();
            checkCollisions();
            if(atWorldEdge())
            {
                getWorld().removeObject(this);   
            }
        }
    }
    
    public void checkCollisions()
    {
        Line line = (Line) getOneIntersectingObject(Line.class);
            if(line != null){
                getWorld().addObject(new Sign(), getX(),getY());
                if(!destroy)
                {
                bounceSonar();
                destroy = true;
                }
                else
                {
                    life -= life;
                }
            }
    }
    
}