import greenfoot.*;  // (World, Actor, GreenfootImage, Greenfoot and MouseInfo)
import java.util.*;
import java.lang.IllegalStateException;

/**
 * Write a description of class Submarine here.
 * 
 * @author (your name) 
 * @version (a version number or a date)
 */
public class Submarine extends Mover
{
    private int s;
    private int ss;
    private int sd;
    private int msd = 30;
    private int b;
    private int mbd = 200;
    private Sea sea;
    private int x;
    private int y;
    private boolean aaa;
    private boolean autoSonar;
    private GreenfootImage image0 = new GreenfootImage("Submarine.png");
    private GreenfootImage image180 = new GreenfootImage("SubmarineF.png");
    
    private int askd;
    private int askdd;

   int life = 5000;
    
    public Submarine()
    {
        increaseSpeed(new Vector(getRotation(), 0.1));
        GreenfootImage image = getImage();
        image.scale(30,10);
        
    }
    
    public void addedToWorld(World w)
    {
        sea = (Sea) w;
    }
    
    public void act() 
    {
        move();
        checkKeys();
        checkWon();
        checkCollision();
        if(autoSonar)
        {
            useSonar();
        }
        bubble();
        sd++;
        b++;
        askd++;
        askdd++;
        if(life <= 0)
        {
         bubbleDestroy(); 
         setLocation(sea.getWidth()-50, sea.getHeight()-10);                
         getSpeed().reset();
         life=5000;
        }else{            
        life--;      
        }  
    }    
    
    public void checkCollision()
    {    
        List p = getIntersectingObjects(null);
        Iterator i = p.iterator();
        x = getX();
        y = getY();
        while (i.hasNext())
        {
            Actor a = (Actor) i.next();
            if( (a instanceof  Line)) { 
                Greenfoot.playSound("destroyed.wav");
                b=0;
                bubbleDestroy();     
                setLocation(sea.getWidth()-50, sea.getHeight()-10);                
                getSpeed().reset();
                move();
            }
        }        
    }
    
    public void checkKeys()
    {
        if(Greenfoot.isKeyDown("up"))
        {
            increaseSpeed(new Vector(-90, 0.3));
            getWorld().addObject(new Bubble(false), getX()+0, getY()+5);
            getWorld().addObject(new Bubble(false), getX()+10, getY()+5);
            getWorld().addObject(new Bubble(false), getX()-10, getY()+5);
            aaa=true;
        }     
        if(Greenfoot.isKeyDown("down"))
        {
            increaseSpeed(new Vector(+90, 0.3));
            bubbleDown(1);
        }
        if(Greenfoot.isKeyDown("right"))
        {            
            setRotation(0);
            getWorld().addObject(new Bubble(false), getX()-20, getY());
            getWorld().addObject(new Bubble(false), getX()-25, getY());
            getWorld().addObject(new Bubble(false), getX()-30, getY());       
            increaseSpeed(new Vector(0, 0.2));
            setImage(image0);
        }           
        if(Greenfoot.isKeyDown("left"))
        {            
            setImage(image180);
            getWorld().addObject(new Bubble(false), getX()+20, getY());
            getWorld().addObject(new Bubble(false), getX()+25, getY());
            getWorld().addObject(new Bubble(false), getX()+30, getY());        
            increaseSpeed(new Vector(180, 0.2));    
            
        }      
        if(Greenfoot.isKeyDown("space") || Greenfoot.isKeyDown(" "))
        {         
            useSonar();
        }
        if(Greenfoot.isKeyDown("q"))
        {         
            activateAutoSonar();
        }

    }
    
    public void bubble()
    {
        if(b >= mbd)
        {
            getWorld().addObject(new Bubble(), getX(), getY());
            //getWorld().addObject(new Bubble(), getX(), getY());
            //getWorld().addObject(new Bubble(), getX(), getY());
            b = 0;
        }
    }
    
    public void bubbleDown(int delay)
    {
        //if(b >= delay)
        //{
            getWorld().addObject(new Bubble(false), getX()+0, getY());
            //getWorld().addObject(new Bubble(false), getX()+5, getY());
            getWorld().addObject(new Bubble(false), getX()+10, getY());
            //getWorld().addObject(new Bubble(false), getX()-0, getY());
            //getWorld().addObject(new Bubble(false), getX()-5, getY());
            getWorld().addObject(new Bubble(false), getX()-10, getY());
            b = 0;
        //}
    }
    
    public void useSonar()
    {
           if(sd >= msd)
            {   
                Greenfoot.playSound("sonar.wav");
                while(s <= 360)
                {
                     Sonar sonar = new Sonar(s);
                     getWorld().addObject(sonar, getX(), getY());
                     s++;   
                }
            sd = 0;
            s = 0;
            }
    }
    
    public void checkWon()
    {
        if(getY() <= 80)
        {
            b = 0; // avoid bubble sounds :D
            Greenfoot.playSound("singleWave.wav"); 
            Greenfoot.playSound("ocean.wav");
            autoSonar = false;
            Sea sea = (Sea) getWorld();
            sea.gameWon();
        }
    }
    
    public void activateAutoSonar()
    {
        if(askd >= 30){
        if(!autoSonar){
           autoSonar = true;
        }else
        {
            deactivateAutoSonar();   
        }
        askd = 0;
    }
    }
    
    public void deactivateAutoSonar()
    {
        if(askd >= 30 ){
        if(autoSonar){
           autoSonar = false;
        }else{
            activateAutoSonar();   
        }
        askd = 0;
    }
    }
    
    public void bubbleDestroy()
    {
     while(ss <= 360)
                {
                     Bubble bubble = new Bubble(false,ss);
                     sea.addObject(bubble, x, y);
                     ss+=1;   
                }   
                ss = 0;
    }

                

    
    
}
