import greenfoot.*;  // (World, Actor, GreenfootImage, Greenfoot and MouseInfo)
import java.util.*;

/**
 * Write a description of class Bubles here.
 * 
 * @author (your name) 
 * @version (a version number or a date)
 */
public class Bubble extends Mover
{
    private int life = Greenfoot.getRandomNumber(50);
    private int x;
    private int y;
    private boolean disable1;

    
    public void addedToWorld(World world)
    {
        Sea sea = (Sea) world;   
    }
    
    public Bubble()
    {
        
        GreenfootImage image = getImage();
        int sf = image.getWidth();
        int size = Greenfoot.getRandomNumber(sf)+1;
        image.scale(size, size);
        setRotation(-90);
        increaseSpeed(new Vector(getRotation(), 5));
        Greenfoot.playSound("bubble.wav");
    }
    
    public Bubble(boolean playSound)
    {
        GreenfootImage image = getImage();
        int sf = image.getWidth();
        int size = Greenfoot.getRandomNumber(sf)+1;
        image.scale(size, size);
        setRotation(-90);
        if(playSound)
        {
        Greenfoot.playSound("bubble.wav");
        }
    }
   
    
    public Bubble(boolean playSound, int rotation)
    {
        GreenfootImage image = getImage();
        int sf = image.getWidth();
        int size = Greenfoot.getRandomNumber(sf)+1;
        image.scale(size, size);
        setRotation(rotation);
        increaseSpeed(new Vector(rotation, Greenfoot.getRandomNumber(10)/10));
        if(playSound)
        {
        Greenfoot.playSound("bubble.wav");
        }
    }
    
    
    public void act() 
    {
        if(life <= 0)
        {
            getWorld().removeObject(this); 
        }
        else
        {
        move(); 
        turn(Greenfoot.getRandomNumber(60)-30);
        increaseSpeed(new Vector(getRotation(), 0.5));   
        checkCollision();
        if(atWorldEdge())
            {
                getWorld().removeObject(this);   
            }
        }
        life--;
    }    
    
    public void checkCollision()
    {
       
        Line line = (Line) getOneIntersectingObject(Line.class);
            if(line != null){
                 bounceBubble();   
            }
        
    }
    

}
